/**
 * @param min - Minimum random int
 * @param max - Maximum random int
 * @returns a random int in the range [min, max], or -1 if either of the following conditions are met:
 *  - min and/or max are not of type 'number', NaN, or Infinity
 *  - min > max
 */
export declare function randomInt(min: number, max: number): number;
/**
 * Performs a shallow comparison between 2 arrays.
 * @param {Array} a1
 * @param {Array} a2
 * @returns true if the array contents are strictly equal (===); false otherwise
 */
export declare function shallowEqual<T>(a1: Array<T>, a2: Array<T>): boolean;
/**
 * Performs an in-place shuffle.
 * Implemented using the Fisher-Yates/Knuth shuffle algorithm.
 * @param list - Array of items to shuffle in-place.
 */
export declare function shuffle<T>(list: Array<T>): any;
